import { NextPageContext, GetServerSidePropsContext, GetServerSideProps, GetStaticPropsContext, GetStaticProps } from 'next';

declare type Gip<T> = (ctx: NextPageContext) => T | Promise<T>;
declare type ComposeInitialPropsParams<T extends unknown[], CompositeT, U = CompositeT> = {
    readonly use: T;
    readonly resolver?: (props: CompositeT, context: NextPageContext) => U | Promise<U>;
};
declare function composeInitialProps<T0, CompositeT = T0, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, CompositeT = T0 & T1, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, CompositeT = T0 & T1 & T2, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, CompositeT = T0 & T1 & T2 & T3, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, CompositeT = T0 & T1 & T2 & T3 & T4, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, CompositeT = T0 & T1 & T2 & T3 & T4 & T5, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, T7, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>, Gip<T7>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>, Gip<T7>, Gip<T8>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>, Gip<T7>, Gip<T8>, Gip<T9>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>, Gip<T7>, Gip<T8>, Gip<T9>, Gip<T10>], CompositeT, U>): Gip<U>;
declare function composeInitialProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10 & T11, U = CompositeT>(params: ComposeInitialPropsParams<[Gip<T0>, Gip<T1>, Gip<T2>, Gip<T3>, Gip<T4>, Gip<T5>, Gip<T6>, Gip<T7>, Gip<T8>, Gip<T9>, Gip<T10>, Gip<T11>], CompositeT, U>): Gip<U>;

declare type Gssp<T> = GetServerSideProps<T>;
declare type ComposeServerSidePropsParams<T extends unknown[], CompositeT, U = CompositeT> = {
    readonly use: T;
    readonly resolver?: (props: CompositeT, context: GetServerSidePropsContext) => U | Promise<U>;
};
declare function composeServerSideProps<T0, CompositeT = T0, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, CompositeT = T0 & T1, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, CompositeT = T0 & T1 & T2, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, CompositeT = T0 & T1 & T2 & T3, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, CompositeT = T0 & T1 & T2 & T3 & T4, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, CompositeT = T0 & T1 & T2 & T3 & T4 & T5, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, T7, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>, Gssp<T7>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>, Gssp<T7>, Gssp<T8>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>, Gssp<T7>, Gssp<T8>, Gssp<T9>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>, Gssp<T7>, Gssp<T8>, Gssp<T9>, Gssp<T10>], CompositeT, U>): Gssp<U>;
declare function composeServerSideProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10 & T11, U = CompositeT>(params: ComposeServerSidePropsParams<[Gssp<T0>, Gssp<T1>, Gssp<T2>, Gssp<T3>, Gssp<T4>, Gssp<T5>, Gssp<T6>, Gssp<T7>, Gssp<T8>, Gssp<T9>, Gssp<T10>, Gssp<T11>], CompositeT, U>): Gssp<U>;

declare type Gsp<T> = GetStaticProps<T>;
declare type RevalidateCompositionType = 'min' | 'max';
declare type ComposeStaticPropsParams<T extends unknown[], CompositeT, U = CompositeT> = {
    readonly use: T;
    readonly resolver?: (props: CompositeT, context: GetStaticPropsContext) => U | Promise<U>;
    readonly revalidate?: number | RevalidateCompositionType;
};
declare function composeStaticProps<T0, CompositeT = T0, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, CompositeT = T0 & T1, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, CompositeT = T0 & T1 & T2, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, CompositeT = T0 & T1 & T2 & T3, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, CompositeT = T0 & T1 & T2 & T3 & T4, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, CompositeT = T0 & T1 & T2 & T3 & T4 & T5, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, T7, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>, Gsp<T7>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>, Gsp<T7>, Gsp<T8>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>, Gsp<T7>, Gsp<T8>, Gsp<T9>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>, Gsp<T7>, Gsp<T8>, Gsp<T9>, Gsp<T10>], CompositeT, U>): Gsp<U>;
declare function composeStaticProps<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, CompositeT = T0 & T1 & T2 & T3 & T4 & T5 & T6 & T7 & T8 & T9 & T10 & T11, U = CompositeT>(params: ComposeStaticPropsParams<[Gsp<T0>, Gsp<T1>, Gsp<T2>, Gsp<T3>, Gsp<T4>, Gsp<T5>, Gsp<T6>, Gsp<T7>, Gsp<T8>, Gsp<T9>, Gsp<T10>, Gsp<T11>], CompositeT, U>): Gsp<U>;

export { ComposeInitialPropsParams, ComposeServerSidePropsParams, ComposeStaticPropsParams, RevalidateCompositionType, composeInitialProps, composeServerSideProps, composeStaticProps };
